#if !defined(AFX_COLOREDTEXTVIEW_H__E1F4073E_CB0B_11D1_82DF_0080C82BD965__INCLUDED_)
#define AFX_COLOREDTEXTVIEW_H__E1F4073E_CB0B_11D1_82DF_0080C82BD965__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// ColoredTextView.h : header file
//

#include <fstream.h>
#include <afx.h>
#include "oreceiver.h"
//#include "InputLine.h"	// Added by ClassView

#define buffersize 10000
#define endl	"\r\n"

class CFileReceiver : public COReceiver
{
public:
	ofstream *file;
	CFileReceiver(char *filename)
	{
		file=new ofstream(filename);
	}
	virtual int RecOutput(CString data)
	{
		*file << data << "\n";
		return 1;
	}
	~CFileReceiver()
	{
		file->close();
	}
};

class CColor
{
#define BOLD		0x01
#define UNDERSCORE	0x08
#define BLINK		0x10
#define REVERSE		0x40
protected:
	char color; //10's place is background, 1's place is foreground
	unsigned char attributes;
//bit	code	function
//0		[1m		Intensity  only on
//3		[4m		Underscore only on
//4		[5m		Blinking   only on
//6		[7m		Reverse    only on
//7		[8m		Concealed (invisible)
public:
	char GetForeground();
	 CColor();
	operator COLORREF( );
	BOOL InterpretColor(char pCode);
	int SetBackground(int pBackground);
	int SetForeground(int pForeground);
	void Reset();
};

class CLine
{
	public:
		BOOL IsEmpty();
		 CLine(CLine &copy);
	CLine();
	~CLine();
	CColor AddText(CString text,CColor oldcolor);
	CColor AppendOldText(CString text,int num=-1);
	CString GetText();
	CString GetText(int ending);
	void ResetTexts();
	CColor FindColor(CColor oldcolor,int num);
	void RemoveReturns(int num);
	CLine& operator = (CLine &source);
	CArray<CString, CString&> texts;
	CArray<CColor, CColor&> colors;
	bool linewrap;
};

/////////////////////////////////////////////////////////////////////////////
// CColoredText view

class CColoredText : public CWnd
{
protected:
	CColoredText();           // protected constructor used by dynamic creation

	DECLARE_DYNCREATE(CColoredText)
		
		// Attributes
public:
	CColor currentcolor;
	CScrollBar scroller;
	CList<CLine, CLine&> lines;
	int maxlinenum;
	COReceiver *rec;
	CFont tf;
	
	// Operations
public:
	COReceiver *SetReceiver(COReceiver *pRec);
	virtual BOOL Create(CRect& rect,CWnd* pParentWnd,UINT nID);
	BOOL dirtypos;
	CColoredText(COReceiver* o,int mlinenum);
	virtual ~CColoredText();

	void SetCharWidths();
	void Append(CString text,int sendtorec);
	//void SendToReceiver(const char *text);
	int FindStringWidth(CString adding);		
	
	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CColoredText)
protected:

	/*virtual afx_msg void OnClose( );

	virtual void EvLButtonDown(uint, TPoint& point);
	
	virtual void EvRButtonDown(uint, TPoint&);
	
	virtual void EvPaint();
	
	virtual void EvVScroll(uint scrollCode, uint thumbPos, HWND hWndCtl);*/

	//}}AFX_VIRTUAL

// Implementation
protected:
	void CheckTooManyLines();

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(CColoredText)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnPaint();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	//}}AFX_MSG
	int checkwidth;
	int checkheight;
	int cwidths[256];
	int cheight;

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////


//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_COLOREDTEXTVIEW_H__E1F4073E_CB0B_11D1_82DF_0080C82BD965__INCLUDED_)
