// GUIStreamBuf.cpp: implementation of the CGUIStreamBuf class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "GUIStreamBuf.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CGUIStreamBuf::CGUIStreamBuf()
{
	output=0;
	char *base=new char[5];
	setp(base,base+5);
}

CGUIStreamBuf::~CGUIStreamBuf()
{
	delete[] pbase();
}

BOOL CGUIStreamBuf::SetControl(CColoredText * pOutput)
{
	output=pOutput;
	return 1;
}

int CGUIStreamBuf::overflow(int extrachar)
{
	CString out(pbase(),pptr()-pbase());
	if(extrachar!=0)
		out+=(char)extrachar;
	output->Append(out,1);
	setp(pbase(),epptr());
	return extrachar;
}

int CGUIStreamBuf::sputc(int _i)
{
	if(_i=='\n')
		return overflow(_i);
	return streambuf::sputc(_i);
}

int CGUIStreamBuf::xsputn(const char * pBuf, int cbBuf)
{
	int outed=0;
	while(cbBuf-outed)
	{
		outed+=streambuf::xsputn(pBuf+outed,cbBuf-outed);
	}
	
	/*while(cbBuf)
	{
		if(*pBuf=='\n')
		{
			overflow(0);
			return ret;
		}
		pBuf++;
		cbBuf--;
	}*/
    return outed;
}

CGUIStreamBuf::CGUIStreamBuf(CColoredText * pOutput)
{
	output=pOutput;
	char *base=new char[50];
	setp(base,base+50);
}

int CGUIStreamBuf::underflow()
{
	return 0;
}

int CGUIStreamBuf::sync()
{
	if (pptr() > pbase())
	{
		overflow(0);
	}
	return 0;
}

CColoredText* CGUIStreamBuf::GetOutput()
{
	return output;
}
