#include "stdafx.h"

#ifndef EXPRESSI_H
#include "ExpressionObject.h"
#endif

int curtempvar;

CExpressionObject::CExpressionObject(CScanner *scanner,CString end,CExpressionObject *newoldersib, CString end2)
{
	oldersibling=newoldersib;
	saveto=0;
	CString str=scanner->GetNonspaceToken();
	if(str==end||str==end2)
	{
		operand="";
		child=0;
		sibling=0;
		operation="";
		return;
	}
	if(str=="(")
	{
		operand="";
		child=new CExpressionObject(scanner,")",(CExpressionObject *)0,end2);
	}
	else
	{
		operand=str;
		if(operand=="*")
			operand+=scanner->GetNonspaceToken();
		else if(operand=="&")
			operand+=scanner->GetNonspaceToken();
		child=0;
	}
	str=scanner->GetNonspaceToken();
	if(str==end||str==end2)
	{
		sibling=0;
		operation="";
	}
	else
	{
		operation=str;
		sibling=new CExpressionObject(scanner,end,this,end2);
	}
}

CVariable *CExpressionObject::AddTempVar(CBlock *curblock,CProgram *prog,int type,
	CVariable *initialvalue=0)
{
	curtempvar++;
	char temp[10];
	sprintf(temp,"%d",curtempvar);
	CString name=TEMPVARPREFIX;
	name+=temp;
	CVariable *var=new CVariable(curblock,type,name,0,initialvalue);
	curblock->AddItem(var);
	return var;
}

CVariable *CExpressionObject::DecodeA(CBlock *curblock,CProgram *prog,
	CVariable *newsaveto,CExpressionObject *&curcheck)
{
	if(!GetOperationLevel("A",curcheck->operation))
	{
		return GetVariable(curblock,prog,curcheck->operand,0);
	}

	CExpressionObject *oldcheck;

	saveto=newsaveto;
	StabalizeSaveto(curblock,prog);

	while(curcheck&&GetOperationLevel("A",curcheck->operation))
	{
		/*else if(curcheck->operation=="=")
		{
			if(curcheck!=this&&!(curcheck==this))
			{
				curcheck->saveto=curcheck->GetVariable(curblock,prog);
				curblock->AddItem(new CAssignCommand(curblock,prog,saveto,
					curcheck->DecodeExpression(curblock,prog)));
				curcheck=0;
				return saveto;
			}
			else
			{
				if(!saveto)
					saveto=GetVariable(curblock,prog);
				CExpressionObject *tempcheck=sibling;
				CVariable *sibvar=tempcheck->Decode(curblock,prog,saveto,tempcheck);
					//curcheck=tempcheck->oldersibling;
					if(sibvar->constant)
						curblock->AddItem(new CAssignCommand(curblock,prog,saveto,
							sibvar));
					else if(sibvar!=saveto)
					{
						//curcheck->sibling->saveto=saveto;
//						curblock->AddItem(new AssignCommand(curblock,prog,saveto,
//						curcheck->sibling->DecodeExpression(curblock,prog)));
						curblock->AddItem(new CAssignCommand(curblock,prog,saveto,
							sibvar));
						//curcheck=0;
						//return saveto;
					}
				curcheck=tempcheck->oldersibling;
			}
		}*/
		/*else if(curcheck->operation=="=="&&curcheck==this)
		{
			saveto=GetVariable(curblock,prog);
			CVariable *var=AddTempVar(curblock,prog,varBool);
			curblock->AddItem(new CAssignCommand(curblock,prog,var,new CVariable(curblock,"0")));
			curblock->AddItem(new CCompareCommand(curblock,prog,saveto,
				curcheck->sibling->DecodeExpression(curblock,prog)));
			CIfStatementBlock *ifblock=new CIfStatementBlock(curblock,prog,"==");
			curblock->AddItem(ifblock);
			ifblock->AddItem(new CAssignCommand(ifblock,prog,var,new CVariable(curblock,"1")));
			return var;
		}*/

		if(GetOperationLevel("A",curcheck->operation)>1)
		{
			DecodeM(curblock,prog,saveto,curcheck);
		}
		else
		{
			if(curcheck==this)
			{
				LoadToSaveto(curblock,prog);
			}
			
			if(curcheck->sibling)
			{
				oldcheck=curcheck;
				curcheck=curcheck->sibling;
			}
			else
			{
				curcheck=0;
				break;
			}

			if(oldcheck->operation=="+")
			{
				curblock->AddItem(new CAddtoCommand(curblock,prog,saveto,
				curcheck->DecodeM(curblock,prog,0,curcheck)));
			}
			else
			{
				gout << "Unknown operator:" << oldcheck->operation << endl;
			}
		}
	}
	return saveto;
}

CVariable *CExpressionObject::DecodeM(CBlock *curblock,CProgram *prog,
	CVariable *newsaveto,CExpressionObject *&curcheck)
{
	//newsaveto should be ready to be erased if given

	if(!GetOperationLevel("M",curcheck->operation))
	{
		return GetVariable(curblock,prog,operand,0);
	}
	saveto=newsaveto;
	StabalizeSaveto(curblock,prog);
	//incase this was just called to be sure there wasn't an * or a /.
	CExpressionObject *oldcheck;
	while(curcheck&&GetOperationLevel("M",curcheck->operation))
	{
		if(GetOperationLevel("M",curcheck->operation)>1)
		{
		}
		else if(curcheck->operation=="=")
		{
			if(curcheck->sibling)
			{
				oldcheck=curcheck;
				curcheck=curcheck->sibling;
			}
			else
			{
				curcheck=0;
				break;
			}

			if(oldcheck->operand!="")
			{
				CVariable *oldsaveto=saveto;
				saveto=GetVariable(curblock,prog,oldcheck->operand);
				curcheck->DecodeE(curblock,prog,saveto,curcheck);
				curblock->AddItem(new CAssignCommand(curblock,prog,oldsaveto,
					saveto));
			}
			else if(curcheck->operation=="")
			{
				curblock->AddItem(new CAssignCommand(curblock,prog,saveto,
					curcheck->DecodeA(curblock,prog,0,curcheck)));
			}
			else
			{
				curcheck->DecodeE(curblock,prog,saveto,curcheck);
			}
		}
		else
		{
			if(curcheck==this)
			{
				LoadToSaveto(curblock,prog);
			}
			if(curcheck->sibling)
			{
				oldcheck=curcheck;
				curcheck=curcheck->sibling;
			}
			else
			{
				curcheck=0;
				break;
			}

			if(oldcheck->operation=="*")
			{
				curblock->AddItem(new CMultiplyCommand(curblock,prog,saveto,
					curcheck->GetVariable(curblock,prog)));
				//curcheck->sibling->Decode(curblock,prog,saveto,curcheck);
			}
			else
			{
				gout << "Unknown operator:" << oldcheck->operation << endl;
			}
		}
	}
	return saveto;
}

char CExpressionObject::Find(CString foperator,CExpressionObject **lastfind)
{
	CExpressionObject *lastcheck;
	if(*lastfind)
		lastcheck=(*lastfind)->sibling;
	else
		lastcheck=this;
	if(!lastcheck)
	{
		*lastfind=this;
		return 0;
	}
	while(lastcheck->operation!=foperator)
	{
		lastcheck=lastcheck->sibling;
		if(!lastcheck)
		{
			*lastfind=this;
			return 0;
		}
	}
	*lastfind=lastcheck->sibling;
	return 1;
}

void CExpressionObject::LoadToSaveto(CBlock * curblock, CProgram * prog)
{
	if(operand=="")
		return;
	CVariable *var=GetVariable(curblock,prog,operand,saveto);
	if(var!=saveto)
	{
		curblock->AddItem(new CAssignCommand(curblock,prog,saveto,
			var));
	}
}

void CExpressionObject::StabalizeSaveto(CBlock *curblock,CProgram *prog)
{
	if(!saveto)
		saveto=AddTempVar(curblock,prog,GetVarType(curblock,prog));
}

int CExpressionObject::GetOperationLevel(CString curlevel,CString operation)
{
	int absolutelevel;
#define MLEVEL	3
#define ALEVEL	2
#define ELEVEL	1
	if(operation=="*")
	{
		absolutelevel=MLEVEL;
	}
	else if(operation=="/")
	{
		absolutelevel=MLEVEL;
	}
	else if(operation=="+")
	{
		absolutelevel=ALEVEL;
	}
	else if(operation=="-")
	{
		absolutelevel=ALEVEL;
	}
	else if(operation=="=")
	{
		absolutelevel=MLEVEL;
	}
	else if(operation=="==")
	{
		absolutelevel=ELEVEL;
	}
	else if(operation=="<")
	{
		absolutelevel=ELEVEL;
	}
	else if(operation==">")
	{
		absolutelevel=ELEVEL;
	}
	else if(operation=="<=")
	{
		absolutelevel=ELEVEL;
	}
	else if(operation==">=")
	{
		absolutelevel=ELEVEL;
	}
	else if(operation=="!=")
	{
		absolutelevel=ELEVEL;
	}
	else if(operation=="")
	{
		return 0;
	}
	else
	{
		gout << "Unknown opcode:" << operation << endl;
		return 0;
	}

	if(curlevel=="M")
	{
		return absolutelevel-MLEVEL+1;
	}
	else if(curlevel=="A")
	{
		return absolutelevel-ALEVEL+1;
	}
	else if(curlevel=="E")
	{
		return absolutelevel-ELEVEL+1;
	}
	return -1;
}

CVariable * CExpressionObject::DecodeE(CBlock * curblock, CProgram * prog, CVariable * newsaveto, CExpressionObject * & curcheck)
{
	CExpressionObject *oldcheck;

	saveto=newsaveto;
	StabalizeSaveto(curblock,prog);

	while(curcheck&&GetOperationLevel("E",curcheck->operation))
	{
		/*else if(curcheck->operation=="=")
		{
			if(curcheck!=this&&!(curcheck==this))
			{
				curcheck->saveto=curcheck->GetVariable(curblock,prog);
				curblock->AddItem(new CAssignCommand(curblock,prog,saveto,
					curcheck->DecodeExpression(curblock,prog)));
				curcheck=0;
				return saveto;
			}
			else
			{
				if(!saveto)
					saveto=GetVariable(curblock,prog);
				CExpressionObject *tempcheck=sibling;
				CVariable *sibvar=tempcheck->Decode(curblock,prog,saveto,tempcheck);
					//curcheck=tempcheck->oldersibling;
					if(sibvar->constant)
						curblock->AddItem(new CAssignCommand(curblock,prog,saveto,
							sibvar));
					else if(sibvar!=saveto)
					{
						//curcheck->sibling->saveto=saveto;
//						curblock->AddItem(new AssignCommand(curblock,prog,saveto,
//						curcheck->sibling->DecodeExpression(curblock,prog)));
						curblock->AddItem(new CAssignCommand(curblock,prog,saveto,
							sibvar));
						//curcheck=0;
						//return saveto;
					}
				curcheck=tempcheck->oldersibling;
			}
		}*/
		/*else if(curcheck->operation=="=="&&curcheck==this)
		{
			saveto=GetVariable(curblock,prog);
			CVariable *var=AddTempVar(curblock,prog,varBool);
			curblock->AddItem(new CAssignCommand(curblock,prog,var,new CVariable(curblock,"0")));
			curblock->AddItem(new CCompareCommand(curblock,prog,saveto,
				curcheck->sibling->DecodeExpression(curblock,prog)));
			CIfStatementBlock *ifblock=new CIfStatementBlock(curblock,prog,"==");
			curblock->AddItem(ifblock);
			ifblock->AddItem(new CAssignCommand(ifblock,prog,var,new CVariable(curblock,"1")));
			return var;
		}*/

		if(GetOperationLevel("E",curcheck->operation)>1)
		{
			DecodeA(curblock,prog,saveto,curcheck);
		}
		else
		{
			if(curcheck==this)
			{
				LoadToSaveto(curblock,prog);
			}
			
			if(curcheck->sibling)
			{
				oldcheck=curcheck;
				curcheck=curcheck->sibling;
			}
			else
			{
				curcheck=0;
				break;
			}
			
			if(oldcheck->operation=="=="||
				oldcheck->operation=="<"||
				oldcheck->operation==">"||
				oldcheck->operation=="<="||
				oldcheck->operation==">="||
				oldcheck->operation=="!=")
			{
				CVariable *op2=curcheck->DecodeA(curblock,prog,0,curcheck);
				CString test=oldcheck->operation;
				curblock->AddItem(new CCompareCommand(curblock,prog,saveto,op2,test));
				CIfStatementBlock *ifblock=new CIfStatementBlock(curblock,prog,
					test);
				curblock->AddItem(ifblock);
				ifblock->AddItem(new CAssignCommand(curblock,prog,saveto,
					new CVariable(ifblock,"1")));
				ifblock->GetElse()->AddItem(new CAssignCommand(curblock,
					prog,saveto,new CVariable(ifblock,"0")));
			}
			else
			{
				gout << "Unknown operator:" << oldcheck->operation << endl;
			}

		}
	}
	return saveto;
}

CVariable * CExpressionObject::DecodeExpression(CBlock * curblock, CProgram * prog)
{
	if(sibling->operand==""&&!sibling->child&&!sibling->saveto)
		return saveto;
	CExpressionObject *curcheck=this;
	return DecodeE(curblock,prog,saveto,curcheck);
}

int CExpressionObject::GetVarType(CBlock * curblock, CProgram * prog)
{
	if(child)
	{
		return child->GetVarType(curblock,prog);
	}
	CVariable *var=curblock->FindVariable(operand);
	if(!var)
		var=new CVariable(curblock,operand);
	return var->GetType();
}

CString CExpressionObject::DecodeForIf(CBlock * curblock, CProgram * prog)
{
	gout << "op=" << operation << endl;
	CExpressionObject *oldcheck;
	CExpressionObject *curcheck=this;

	if(!GetOperationLevel("E",curcheck->operation))
	{
		CVariable *op2=new CVariable(curblock,"1");
		CString test=">=";
		curblock->AddItem(new CCompareCommand(curblock,prog,GetVariable(curblock,prog,operand),op2,test));
		return test;
	}
	while(curcheck&&GetOperationLevel("E",curcheck->operation))
	{
		if(GetOperationLevel("E",curcheck->operation)>1)
		{
			DecodeA(curblock,prog,saveto,curcheck);
		}
		else
		{
			if(curcheck->sibling)
			{
				oldcheck=curcheck;
				curcheck=curcheck->sibling;
			}
			else
			{
				curcheck=0;
				break;
			}
			
			if(oldcheck->operation=="=="||
				oldcheck->operation=="<"||
				oldcheck->operation==">"||
				oldcheck->operation=="<="||
				oldcheck->operation==">="||
				oldcheck->operation=="!=")
			{
				if(!IsLastEOperation(curcheck))
				{
					CVariable *op2=curcheck->DecodeA(curblock,prog,0,curcheck);
					if(saveto)
					{
						CString test=oldcheck->operation;
						curblock->AddItem(new CCompareCommand(curblock,prog,saveto,op2,test));
						CIfStatementBlock *ifblock=new CIfStatementBlock(curblock,prog,
							test);
						curblock->AddItem(ifblock);
						ifblock->AddItem(new CAssignCommand(curblock,prog,saveto,
							new CVariable(ifblock,"1")));
						ifblock->GetElse()->AddItem(new CAssignCommand(curblock,
							prog,saveto,new CVariable(ifblock,"0")));
					}
					else
					{
						StabalizeSaveto(curblock,prog);
						curblock->AddItem(new CAssignCommand(curblock,prog,
							saveto,new CVariable(curblock,"0")));
						CString test=oldcheck->operation;
						curblock->AddItem(new CCompareCommand(curblock,prog,
							oldcheck->DecodeA(curblock,prog,0,oldcheck),op2,test));
						CIfStatementBlock *ifblock=new CIfStatementBlock(curblock,prog,
							test);
						curblock->AddItem(ifblock);
						ifblock->AddItem(new CAssignCommand(curblock,prog,saveto,
							new CVariable(ifblock,"1")));
					}
				}
				else
				{
					CVariable *op2=curcheck->DecodeA(curblock,prog,0,curcheck);
					CString test=oldcheck->operation;
					if(saveto)
						curblock->AddItem(new CCompareCommand(curblock,prog,
						saveto,op2,test));
					else
						curblock->AddItem(new CCompareCommand(curblock,prog,
						oldcheck->DecodeA(curblock,prog,0,oldcheck),op2,test));
					return test;
				}
			}
			/*If there are ever any operations that would change the variable
			use this:
			StabalizeSaveto(curblock,prog);
			if(curcheck==this)
			{
				LoadToSaveto(curblock,prog);
			}*/
			else
			{
				gout << "Unknown operator:" << oldcheck->operation << endl;
			}
		}
	}
	CVariable *op2=new CVariable(curblock,"1");
	CString test=">=";
	curblock->AddItem(new CCompareCommand(curblock,prog,saveto,op2,test));
	return test;
}

BOOL CExpressionObject::IsLastEOperation(CExpressionObject * startat)
{
	while(startat)
	{
		if(GetOperationLevel("E",startat->operation)==1)
		{
			return 0;
		}
		startat=startat->sibling;
	}
	return 1;
}
