#include "stdafx.h"
#include "function.h"
#include "program.h"
#include "variable.h"
#include "variablemanager.h"

CFunction::CFunction(CProgram *newprog,CString newname) :
	CBlock(newprog,newprog)
{
	name=newname;
	type="CFunction";
	parameternum=0;
}

CString CFunction::GetName()
{
	return name;
}

void CFunction::PreTo68kAsm()
{
	if(asmcode!="")
		return;
	for(int i=0; i<parameternum; i++)
	{
		if(parameters[i]->IsPointer())
		{
			parameters[i]->registeraccess="a";
			parameters[i]->registeraccess+=(char)(i+48);
			asmcode+=vmanager->SetAddressRegister(i,parameters[i]);
		}
		else
		{
			parameters[i]->registeraccess="d";
			parameters[i]->registeraccess+=(char)(i+48);
			asmcode+=vmanager->SetDataRegister(i,parameters[i]);
		}
	}

	CBlock::PreTo68kAsm();
	CString temp=asmcode;
	asmcode=name+":\n";
	asmcode+=temp;
	asmcode+=FormatCode("rts","","; return;\n\n");			//Two newlines added for easier readablity
	usedregisters=vmanager->regs;
}

int CFunction::AddParameter(CVariable * toadd)
{
	if(!toadd->constant)
	{
		int found=0;
		for(int i=0; i<parameternum; i++)
		{
			if(toadd->name==parameters[i]->name)
			{
				found=i;
			}
		}
		if(found)
		{
			gout << "Error: parameter " << toadd->GetCName() << " already exists!";
			gout << endl;
			return 0;
		}
	}
	if(parameternum%5==0)
	{
		CVariable **temp=new CVariable*[parameternum+5];
		for(int i=0; i<parameternum; i++)
		{
			temp[i]=parameters[i];
		}
		if(parameternum)
			delete[] parameters;
		parameters=temp;
	}
	parameters[parameternum]=toadd;
	return parameternum++;
}

CVariable * CFunction::FindVariable(CString str)
{
	for(int i=0; i<variablenum; i++)
	{
		if(str==variables[i]->name)
		{
			return variables[i];
		}
	}
	for(i=0; i<parameternum; i++)
	{
		if(str==parameters[i]->name)
		{
			return parameters[i];
		}
	}
	if(parent&&parent!=this)
		return parent->FindVariable(str);
	return 0;
}
