// FunctionCall.cpp: implementation of the CFunctionCall class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "FunctionCall.h"
#include "Function.h"
#include "variablemanager.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFunctionCall::~CFunctionCall()
{

}

CFunctionCall::CFunctionCall(CBlock * newparent, CProgram * newprog, CFunction * newfunc) :
	CCommand(newparent,newprog)
{
	func=newfunc;
	parameternum=0;
}

void CFunctionCall::PreTo68kAsm()
{
	if(asmcode!="")
	{
		vmanager->SetOwnedRegs(usedregisters,this);
		return;
	}
	if(parameternum<func->parameternum)
		gout << "Error: not enough parameters!" << endl;
	for(int i=0; i<parameternum; i++)
	{
		parameters[i]->Load(1,i);
	}
	asmcode+=FormatCode("bsr",func->GetName(),"; "+func->GetName()+"();\n");
	vmanager->regs|=func->usedregisters;
}

int CFunctionCall::AddParameter(CVariable * toadd)
{
	if(toadd==0)
		return 0;
	if(!toadd->constant)
	{
		int found=0;
		for(int i=0; i<parameternum; i++)
		{
			if(toadd->name==parameters[i]->name)
			{
				found=i;
			}
		}
		if(found)
		{
			gout << "Error: parameter " << toadd->GetCName() << " already exists!";
			gout << endl;
			return 0;
		}
	}
	if(parameternum%5==0)
	{
		CVariable **temp=new CVariable*[parameternum+5];
		for(int i=0; i<parameternum; i++)
		{
			temp[i]=parameters[i];
		}
		if(parameternum)
			delete[] parameters;
		parameters=temp;
	}
	parameters[parameternum]=toadd;
	return parameternum++;
}
