#include <stdio.h>
#include "stdafx.h"
#include "langobjs.h"
#include "VariableManager.h"
#include "gotocommand.h"

int curiflabel=0;

void CRegisterHolder::ClearRegisters()
{
	int i;
	for(i=0; i<8; i++)
	{
		dataregisters[i]=0;
	}
	for(i=0; i<7; i++)
	{
		addressregisters[i]=0;
	}
	addressregisters[7]=(CVariable *)-1;
}

CRegisterHolder& CRegisterHolder::operator = ( CRegisterHolder &regs )
{
	int i;
	for(i=0; i<8; i++)
	{
		dataregisters[i]=regs.dataregisters[i];
	}
	for(i=0; i<8; i++)
	{
		addressregisters[i]=regs.addressregisters[i];
	}
	return *this;
}

CString CVariableManager::PushVariable(CVariable *toadd,CString useaddr)
{
	if(toadd->constant)
		return "";
	if(useaddr=="")
	{
		if(toadd->GetLastRegisterAccess()!="")
			useaddr=toadd->GetLastRegisterAccess();
		else if(toadd->initialvalue!=0)
			useaddr=toadd->initialvalue->GetName();
	}
	toadd->needed=1;
	if(stacknum%5==0)
	{
		CVariable **temp=new CVariable*[stacknum+5];
		for(int i=0; i<stacknum; i++)
		{
			temp[i]=stack[i];
		}
		if(stacknum)
			delete[] stack;
		stack=temp;
	}
	//A little safety procaution. Later on this will have to be removed if
	//variables are going to be pushed on the stack for parameters.
	CString ret="";
	if(toadd->GetMemoryAccess()=="")
	{
		stack[stacknum++]=toadd;
		stacklevel+=2+toadd->GetSize()%2;
		toadd->stacklevel=stacklevel;
		if(useaddr!="")
			ret+=FormatCode("move"+toadd->GetLengthIdentifier(),
			useaddr+",-(a7)",
			";Backingup variable "+toadd->GetName()+
			" in "+useaddr+" to "+
			toadd->GetMemoryAccess()+".\n");
		else
		{
			CString op1="#";
			op1+=(toadd->GetSize()+toadd->GetSize()%2+48);
			ret+=FormatCode("sub.l",op1+",a7",
				";Pushing variable "+
				toadd->GetName()+" on the stack.\n");
		}
	}
	else
	{
		ret+=FormatCode("move"+toadd->GetLengthIdentifier(),
			useaddr+","+toadd->GetMemoryAccess(),
			";Backingup variable "+toadd->GetName()+
			" in "+useaddr+" to "+
			toadd->GetMemoryAccess()+".\n");
	}
	return ret;
}

CString CVariableManager::CleanStack()
{
	int removed=0;
	CString comment="";
	CString lastvariable="";
	while(stacknum>0&&!stack[stacknum-1]->needed)
	{
		stacknum--;
		stack[stacknum]->SetStackLevel(-1);
		removed+=stack[stacknum]->GetSize()+
			stack[stacknum]->GetSize()%2;
		if(lastvariable!="")
			comment+=lastvariable+", ";
		lastvariable=stack[stacknum]->GetName();
	}
	if(!removed)
		return "";
	if(comment!="")
		comment="Removing variables "+comment+"and "+lastvariable+".";
	else
		comment="Removing variable "+lastvariable+".";
	stacklevel-=removed;
	char temp[10];
	sprintf(temp,"%d",removed);
	return FormatCode("add.l",
		"#"+(CString)temp+",a7",
		";"+comment+"\n");
}

CString CVariableManager::BackupVariables(CCommand *vparent,CRegisterHolder *oregs,
										  CRegisterHolder *cregs)
{
	CString ret;
	if(!cregs)
		cregs=&regs;
	int i;
	for(i=0; i<8; i++)
	{
		if(oregs->dataregisters[i]==0)
			continue;
		if(cregs->dataregisters[i]!=oregs->dataregisters[i])
			if(oregs->dataregisters[i]->parent==vparent)
			{
				CString oldaccess="d";
				oldaccess+=(char)i+48;
				ret+=PushVariable(oregs->dataregisters[i],oldaccess);
			}
	}
	for(i=0; i<7; i++)
	{
		if(oregs->addressregisters[i]==0)
			continue;
		if(cregs->addressregisters[i]!=oregs->addressregisters[i])
			if(oregs->addressregisters[i]->parent==vparent)
			{
				CString oldaccess="a";
				oldaccess+=(char)i+48;
				ret+=PushVariable(oregs->addressregisters[i],oldaccess);
			}
	}
	return ret;
}

CString CVariableManager::Load(CVariable *toload,char dest,int place)
{
	int i;
	if(toload->direct)
	{
		if(dest)
		{
			if(toload->GetName()[0]=='d')
			{
				gout << "Direct data register load." << endl;
				int reg=toload->GetName()[1]-48;
				SetDataRegister(reg,toload);
				toload->SetRegister(toload->GetName());
			}
			/*else if(toload->GetName()[0]=='a')
			{
				gout << "Direct address register load." << endl;
				int reg=toload->GetName()[1]-48;
				SetAddressRegister(reg,toload);
				toload->SetRegister(toload->GetName());
			}*/
		}
		return "";
	}
	else if(toload->constant)
	{
		return "";
	}
	if(place!=-1)
	{
		if(toload->IsPointer())
		{
			CString ret;
			ret+=SetAddressRegister(place,toload);
			toload->registeraccess="a";
			toload->registeraccess+=(char)(place+48);
			if(toload->GetMemoryAccess()!="")
			{
				ret+=FormatCode("move"+toload->GetLengthIdentifier(),
					toload->GetMemoryAccess()+","+
					toload->registeraccess,
					";Loading variable "+toload->GetName()+
					" into register "+toload->registeraccess+".\n");
			}
			else
			{
				if(toload->initialvalue!=0)
				{
					ret+=FormatCode("move"+
						toload->GetLengthIdentifier(),
						toload->initialvalue->GetRegisterAccess()+
						","+toload->GetAccess(),
						";Initializing variable "+toload->GetName()+
						" into register "+
						toload->GetRegisterAccess()+
						" with a value of "+
						toload->initialvalue->GetName()+".\n");
				}
				else
				{
				}
			}
			return ret;
		}
		else
		{
			CString ret;
			ret+=SetDataRegister(place,toload);
			toload->registeraccess="d";
			toload->registeraccess+=(char)(place+48);
			if(toload->GetMemoryAccess()!="")
			{
				ret+=FormatCode("move"+toload->GetLengthIdentifier(),
					toload->GetMemoryAccess()+","+
					toload->registeraccess,
					";Loading variable "+toload->GetName()+
					" into register "+toload->registeraccess+".\n");
			}
			else
			{
				if(toload->initialvalue!=0)
				{
					ret+=FormatCode("move"+
						toload->GetLengthIdentifier(),
						toload->initialvalue->GetRegisterAccess()+
						","+toload->GetAccess(),
						";Initializing variable "+toload->GetName()+
						" into register "+
						toload->GetRegisterAccess()+
						" with a value of "+
						toload->initialvalue->GetName()+".\n");
				}
				else
				{
				}
			}
			return ret;
		}
	}
	else if(toload->usememory)
	{
		if(toload->GetMemoryAccess()=="")
		{
			return PushVariable(toload);
		}
		return "";
	}
	for(i=0; i<8; i++)
	{
		if(toload->IsPointer())
		{
			if(regs.addressregisters[i]==0||
				(i!=7&&
				!regs.addressregisters[i]->needed))
			{
				CString ret=SetAddressRegister(i,toload);
				toload->registeraccess="a";
				toload->registeraccess+=(char)(i+48);
				if(toload->GetMemoryAccess()!="")
				{
					ret+=FormatCode("move"+toload->GetLengthIdentifier(),
						toload->GetMemoryAccess()+","+
						toload->registeraccess,
						";Loading variable "+toload->GetName()+
						" into register "+toload->registeraccess+".\n");
				}
				else
				{
					if(toload->initialvalue!=0)
					{
						ret+=FormatCode("move"+
							toload->GetLengthIdentifier(),
							toload->initialvalue->GetRegisterAccess()+
							","+toload->GetAccess(),
							";Initializing variable "+toload->GetName()+
							" into register "+
							toload->GetRegisterAccess()+
							" with a value of "+
							toload->initialvalue->GetName()+".\n");
					}
					else
					{
					}
				}
				return ret;
			}
		}
		else
		{
			if(regs.dataregisters[i]==0||!regs.dataregisters[i]->needed)
			{
				CString ret=SetDataRegister(i,toload);
				toload->registeraccess="d";
				toload->registeraccess+=(char)(i+48);
				if(toload->GetMemoryAccess()!="")
				{
					ret+=FormatCode("move"+toload->GetLengthIdentifier(),
						toload->GetMemoryAccess()+","+
						toload->registeraccess,
						";Loading variable "+toload->GetName()+
						" into register "+toload->registeraccess+".\n");
				}
				else
				{
					if(toload->initialvalue!=0)
					{
						ret+=FormatCode("move"+
							toload->GetLengthIdentifier(),
							toload->initialvalue->GetRegisterAccess()+
							","+toload->GetAccess(),
							";Initializing variable "+toload->GetName()+
							" into register "+
							toload->GetRegisterAccess()+
							" with a value of "+
							toload->initialvalue->GetName()+".\n");
					}
					else
					{
					}
				}
				return ret;
			}
		}
	}
	for(i=0; i<8; i++)
	{
		if(regs.dataregisters[i]->accesses<=toload->accesses)
		{
			CString ret=SetDataRegister(i,toload);
			toload->registeraccess="d";
			toload->registeraccess+=(char)(i+48);
			if(toload->GetMemoryAccess()!="")
			{
				ret+=FormatCode("move"+toload->GetLengthIdentifier(),
					toload->GetMemoryAccess()+","+
					toload->registeraccess,
					";Loading variable "+toload->GetName()+" into register "+
					toload->registeraccess+".\n");
			}
			else
			{
				if(toload->initialvalue!=0)
				{
					ret+=FormatCode("move"+toload->GetLengthIdentifier(),
						toload->initialvalue->GetName()+","+toload->GetAccess(),
						";Initializing variable "+toload->GetName()+
						" into register "+toload->GetRegisterAccess()+
						" with a value of "+
						toload->initialvalue->GetName()+".\n");
				}
				else
				{
				}
			}
			return ret;
		}
	}
	return NO_EMPTY_REGISTER;
}

CVariable::CVariable(CCommand *newparent,int newtype,CString newname,int newelements
	,CVariable *newinitialvalue)
{
	globalvar=0;
	parent=newparent;
	type=newtype;
	name=newname;
	elements=newelements;
	accesses=0;
	stacklevel=-1;
	registeraccess="";
	oldregisteraccess="";
	needed=1;
	initialvalue=newinitialvalue;
	constant=0;
	direct=0;
	usememory=0;
	if(name=="*"||name=="&")
	{
		direct=1;
		if(name=="&")
			initialvalue->usememory=1;
	}
}

CVariable::CVariable(CCommand *newparent,int value)
{
	char temp[10];
	sprintf(temp,"%d",value);
	CVariable(newparent,temp);
}

CCommand::CCommand(CBlock *newparent,CProgram *newprog)
{
	asmcode="";
	parent=newparent;
	prog=newprog;
	type="CCommand";
}

void CCommand::PreTo68kAsm()
{
	asmcode="!Error, Command::PreTo68kAsm() should not be called.";
	vmanager->regs=usedregisters;
}

CAssignCommand::CAssignCommand(CBlock *newparent,CProgram *newprog,CVariable *newdestination,
							   CVariable *newsource)
							   : CCommand(newparent,newprog)
{
	source=newsource;
	destination=newdestination;
	if(source==destination)
	{
		cout << "Error! source=destination!" << endl;
	}
	source->accesses++;
	destination->accesses++;
}

void CAssignCommand::PreTo68kAsm()
{
	if(asmcode!="")
	{
		vmanager->SetOwnedRegs(usedregisters,this);
		return;
	}
	asmcode=A68kOpcode("move",source,destination)+"\n";
}

CAddtoCommand::CAddtoCommand(CBlock *newparent,CProgram *newprog,CVariable *newdestination,
		CVariable *newsource)
		: CCommand(newparent,newprog)
	{
		source=newsource;
		destination=newdestination;
		source->accesses++;
		destination->accesses++;
	}


void CAddtoCommand::PreTo68kAsm()
{
	if(asmcode!="")
	{
		vmanager->SetOwnedRegs(usedregisters,this);
		return;
	}
	asmcode+=A68kOpcode("add",source,destination)+"\n";
}

CSubtractfromCommand::CSubtractfromCommand(CBlock *newparent,CProgram *newprog,CVariable *newdestination,
		CVariable *newsource)
		: CCommand(newparent,newprog)
	{
		source=newsource;
		destination=newdestination;
		source->accesses++;
		destination->accesses++;
	}

void CSubtractfromCommand::PreTo68kAsm()
{
	if(asmcode!="")
	{
		vmanager->SetOwnedRegs(usedregisters,this);
		return;
	}
	if(source->constant)
	{
		asmcode=destination->Load();
		if(destination->LoadedInRegister())
		{
			asmcode+="\tsubi"+destination->GetLengthIdentifier()+"\t";
			asmcode+=source->GetName();
			asmcode+=",";
			asmcode+=destination->GetRegisterAccess();
			asmcode+="\t\t; "+destination->GetCName()+" -= "+source->GetCName();
			asmcode+=";\n";
			return;
		}
	}
	CRegisterHolder regs;
	regs=vmanager->regs;
	CString temp=destination->Load();
	asmcode+=vmanager->BackupVariables(parent,&regs);
	asmcode+=temp;

	regs=vmanager->regs;
	temp=source->Load();
	asmcode+=vmanager->BackupVariables(parent,&regs);
	asmcode+=temp;
	asmcode+="\tsub"+destination->GetLengthIdentifier()+"\t";
	if(source->constant)
		asmcode+=source->GetName();
	else
		asmcode+=source->GetAccess();
	asmcode+=",";
	asmcode+=destination->GetAccess();
	asmcode+="\t\t; "+destination->GetCName()+" -= "+source->GetCName()+";\n";
}

CVariable *lastcompareop1,*lastcompareop2;

CCompareCommand::CCompareCommand(CBlock *newparent,CProgram *newprog,
	CVariable *newsource,CVariable *newdestination,
	CString &operation) : CCommand(newparent,newprog)
{
	if(newdestination->constant&&!newsource->constant)
	{
		if(operation[0]=='>')
			operation.SetAt(0,'<');
		else if(operation[0]=='<')
			operation.SetAt(0,'>');
		source=newdestination;
		destination=newsource;
	}
	else
	{
		source=newsource;
		destination=newdestination;
	}
	source->accesses++;
	destination->accesses++;
}

void CCompareCommand::PreTo68kAsm()
{
	lastcompareop1=source;
	lastcompareop2=destination;
	if(asmcode!="")
	{
		vmanager->SetOwnedRegs(usedregisters,this);
		return;
	}
	if(source->constant)
	{
		asmcode=destination->Load();
		if(destination->LoadedInRegister())
		{
			asmcode+=FormatCode("cmpi"+
				destination->GetLengthIdentifier(),
				source->GetName()+","+
				destination->GetRegisterAccess(),
				"; "+destination->GetCName()+" - "+
				source->GetCName()+"; //comparing\n");
			return;
		}
	}
	CRegisterHolder regs;
	regs=vmanager->regs;
	CString temp=destination->Load();
	asmcode+=vmanager->BackupVariables(parent,&regs);
	asmcode+=temp;

	regs=vmanager->regs;
	temp=source->Load();
	asmcode+=vmanager->BackupVariables(parent,&regs);
	asmcode+=temp;
	if(source->constant)
		asmcode+=FormatCode("cmp"+
			destination->GetLengthIdentifier(),
			source->GetName()+","+
			destination->GetAccess(),
			"; "+destination->GetCName()+
			" - "+source->GetCName()+"; //comparing\n");
	else
		asmcode+=FormatCode("cmp"+
			destination->GetLengthIdentifier(),
			source->GetAccess()+","+
			destination->GetAccess(),
			"; "+destination->GetCName()+
			" - "+source->GetCName()+"; //comparing\n");
}

CMultiplyCommand::CMultiplyCommand(CBlock *newparent,CProgram *newprog,CVariable *newdestination,
		CVariable *newsource)
		: CCommand(newparent,newprog)
	{
		source=newsource;
		destination=newdestination;
		source->accesses++;
		destination->accesses++;
	}

void CMultiplyCommand::PreTo68kAsm()
{
	if(asmcode!="")
	{
		vmanager->SetOwnedRegs(usedregisters,this);
		return;
	}
	CRegisterHolder regs;
	regs=vmanager->regs;
	CString temp=destination->Load();
	asmcode+=vmanager->BackupVariables(parent,&regs);
	asmcode+=temp;

	regs=vmanager->regs;
	temp=source->Load();
	asmcode+=vmanager->BackupVariables(parent,&regs);
	asmcode+=temp;
	if(source->IsSigned()&&destination->IsSigned())
		asmcode+="\tmuls"+destination->GetLengthIdentifier()+"\t";
	else
		asmcode+="\tmulu"+destination->GetLengthIdentifier()+"\t";
	if(source->constant)
		asmcode+=source->GetName();
	else
		asmcode+=source->GetAccess();
	asmcode+=",";
	asmcode+=destination->GetAccess();
	asmcode+="\t\t; "+destination->GetCName()+" *= "+source->GetCName()+";\n";
}

CBlock::CBlock(CBlock *newparent,CProgram *newprog) : CCommand(newparent,newprog)
{
	commandnum=0;
	variablenum=0;
}

CBlock::~CBlock()
{
	for(int i=0; i<commandnum; i++)
	{
		delete commands[i];
	}
	if(commandnum)
		delete[] commands;
}

int CBlock::AddItem(CCommand *toadd)
{
	if(commandnum%5==0)
	{
		CCommand **temp=new CCommand*[commandnum+5];
		for(int i=0; i<commandnum; i++)
		{
			temp[i]=commands[i];
		}
		if(commandnum)
			delete[] commands;
		commands=temp;
	}
	commands[commandnum]=toadd;
	return commandnum++;
}

int CBlock::AddItem(CVariable *toadd)
{
	if(!toadd->constant)
	{
		int found=0;
		for(int i=0; i<variablenum; i++)
		{
			if(toadd->name==variables[i]->name)
			{
				found=i;
			}
		}
		if(found)
		{
			gout << "Error: variable " << toadd->GetCName() << " already exists!";
			gout << endl;
			return 0;
		}
	}
	if(variablenum%5==0)
	{
		CVariable **temp=new CVariable*[variablenum+5];
		for(int i=0; i<variablenum; i++)
		{
			temp[i]=variables[i];
		}
		if(variablenum)
			delete[] variables;
		variables=temp;
	}
	variables[variablenum]=toadd;
	return variablenum++;
}

CVariable *CBlock::FindVariable(CString str)
{
	for(int i=0; i<variablenum; i++)
	{
		if(str==variables[i]->name)
		{
			return variables[i];
		}
	}
	if(parent&&parent!=this)
		return parent->FindVariable(str);
	return 0;
}

void CBlock::PreTo68kAsm()
{
	if(asmcode!="")
		return;
	CRegisterHolder regs,afterregs;
	int i;
	CString backup;
	CVariableManager oldman;
	for(i=0; i<commandnum; i++)
	{
		regs=vmanager->regs;
		oldman=*vmanager;
		commands[i]->PreTo68kAsm();
		afterregs=vmanager->regs;
		backup=vmanager->BackupVariables(this,&regs);
		if(backup)
		{
			vmanager->Restore(&oldman);
			asmcode+=vmanager->BackupVariables(this,&regs,&afterregs);
			commands[i]->Reset();
			commands[i]->PreTo68kAsm();
		}
		asmcode+=commands[i]->To68kAsm();
		if(commands[i]->type=="CGotoCommand")
			return;
	}
	for(i=0; i<variablenum; i++)
	{
		asmcode+=variables[i]->DoneWith(0);
	}
	asmcode+=vmanager->CleanStack();
}

CString CCommand::To68kAsm()
{
	if(asmcode!="")
	return asmcode;
	CRegisterHolder regs;
	regs=vmanager->regs;
	PreTo68kAsm();
	CString temp=vmanager->BackupVariables(parent,&regs);
	temp+=asmcode;
	return temp;
}

char CCommand::IsParent(CCommand *c)
{
	if(c==parent)
		return 1;
	if(!parent)
		return 0;
	return parent->IsParent(c);
}

char CVariable::IsParent(CCommand *c)
{
	if(c==parent)
		return 1;
	if(!parent)
		return 0;
	return parent->IsParent(c);
}

CIfStatementBlock::CIfStatementBlock(CBlock *newparent,CProgram *newprog,CString newtest) : CBlock(newparent,newprog)
{
	test=newtest;
	elseblock=0;
}

void CIfStatementBlock::PreTo68kAsm()
{
	if(asmcode!="")
		return;
	CRegisterHolder regs,afterregs;
	int i;
	CString endlabel=IFLABELPREFIX;
	char temp[10];
	sprintf(temp,"%d",curiflabel++);
	endlabel+=temp;
	CString opcode;
	if(test=="==")
	{
		opcode="bne";
	}
	else if(test=="<")
	{
		opcode="bge";
	}
	else if(test==">")
	{
		opcode="ble";
	}
	else if(test=="<=")
	{
		opcode="bgt";
	}
	else if(test==">=")
	{
		opcode="blt";
	}
	else if(test=="!=")
	{
		opcode="bne";
	}
	else
	{
		gout << "Unknown test operation:" << test << endl;
	}
	CString backup;
	CVariableManager oldman;
	if(elseblock)
	{
		CString elselabel=endlabel+"else";

		asmcode+=FormatCode(opcode,elselabel,"; if("+
			lastcompareop1->GetCName()+test+
			lastcompareop1->GetCName()+")\n");
		asmcode+=FormatCode("","","; {\n");
		for(i=0; i<commandnum; i++)
		{
			if(commands[i]!=elseblock)
			{
				regs=vmanager->regs;
				oldman=*vmanager;
				commands[i]->PreTo68kAsm();
				afterregs=vmanager->regs;
				backup=vmanager->BackupVariables(this,&regs);
				if(backup)
				{
					vmanager->Restore(&oldman);
					asmcode+=vmanager->BackupVariables(this,&regs,&afterregs);
					commands[i]->Reset();
					commands[i]->PreTo68kAsm();
				}
				asmcode+=commands[i]->To68kAsm();
				if(commands[i]->type=="CGotoCommand")
					goto endloop1;
			}
		}
		for(i=0; i<variablenum; i++)
		{
			asmcode+=variables[i]->DoneWith();
		}
endloop1:
		asmcode+=FormatCode("bra",endlabel,"; }\n");
		asmcode+=FormatCode(elselabel+":","","; else\n");
		asmcode+=FormatCode("","","; {\n");
		asmcode+=elseblock->To68kAsm();
	}
	else
	{
		asmcode+=FormatCode(opcode,endlabel,"; if("+
			lastcompareop1->GetCName()+test+
			lastcompareop2->GetCName()+")\n");
		asmcode+=FormatCode("","","; {\n");
		for(i=0; i<commandnum; i++)
		{
			regs=vmanager->regs;
			oldman=*vmanager;
			commands[i]->PreTo68kAsm();
			afterregs=vmanager->regs;
			backup=vmanager->BackupVariables(this,&regs);
			if(backup)
			{
				vmanager->Restore(&oldman);
				asmcode+=vmanager->BackupVariables(this,&regs,&afterregs);
				commands[i]->Reset();
				commands[i]->PreTo68kAsm();
			}
			asmcode+=commands[i]->To68kAsm();
			if(commands[i]->type=="CGotoCommand")
				goto endloop2;
		}
		for(i=0; i<variablenum; i++)
		{
			asmcode+=variables[i]->DoneWith(0);
		}
		asmcode+=vmanager->CleanStack();
	}
	//Note I have not yet put in the part to change the variablemanager to a
	//special one for if statements where it won't imediately load vars.
	//Kyle Stemen - 6/14/98
	//Shouldn't be a problem if only the if statement's vars are being backed up.
endloop2:
	asmcode+=FormatCode(endlabel+":","","; }\n");
}

CBlock * CIfStatementBlock::GetElse()
{
	if(elseblock)
		return elseblock;
	elseblock=new CBlock(this,prog);
	return elseblock;
}

CIfStatementBlock::~CIfStatementBlock()
{
	if(elseblock)
		delete elseblock;
}

CBlock * CCommand::GetParent()
{
	return parent;
}

CString CVariableManager::Restore(CVariableManager * oldmanager)
{
	CString asmcode;
	for(int i=0; i<8; i++)
	{
		if(oldmanager->regs.dataregisters[i]!=
			regs.dataregisters[i])
		{
			if(regs.dataregisters[i])
				SetDataRegister(i,0);
			if(oldmanager->regs.dataregisters[i])
				oldmanager->regs.dataregisters[i]->Load(0,i);
		}
		if(i<7&&oldmanager->regs.addressregisters[i]!=
			regs.addressregisters[i])
		{
			if(regs.addressregisters[i])
				SetAddressRegister(i,0);
			if(oldmanager->regs.addressregisters[i])
				oldmanager->regs.addressregisters[i]->Load(0,i);
		}
	}
	int firstgood;
	if(oldmanager->stacknum>stacknum)
	{
		firstgood=stacknum-1;
	}
	else
		firstgood=oldmanager->stacknum-1;
	while(firstgood>=0&&oldmanager->stack[firstgood]!=
		stack[firstgood])
	{
		firstgood--;
	}
	for(i=firstgood+1; i<stacknum; i++)
	{
		asmcode+=stack[i]->DoneWith();
	}
	for(i=firstgood+1; i<oldmanager->stacknum; i++)
	{
		asmcode+=PushVariable(oldmanager->stack[i]);
	}
	return asmcode;
}

CVariableManager & CVariableManager::operator =(CVariableManager & newman)
{
	regs=newman.regs;
	stacklevel=newman.stacklevel;

	if(stacknum+stacknum%5<newman.stacknum+newman.stacknum%5)
	{
		if(stacknum)
			delete[] stack;
		stack=new CVariable*[newman.stacknum+newman.stacknum%5];
	}
	for(int i=0; i<newman.stacknum; i++)
	{
		stack[i]=newman.stack[i];
	}
	stacknum=newman.stacknum;
	return *this;
}

void CCommand::Reset()
{
	asmcode="";
}

void CBlock::Reset()
{
	CCommand::Reset();
	for(int i=0; i<commandnum; i++)
	{
		commands[i]->Reset();
	}
}

CRegisterHolder & CRegisterHolder::operator |=(CRegisterHolder & regs)
{
	int i;
	for(i=0; i<8; i++)
	{
		if(regs.dataregisters[i])
			dataregisters[i]=regs.dataregisters[i];
	}
	for(i=0; i<8; i++)
	{
		if(regs.addressregisters[i])
			addressregisters[i]=regs.addressregisters[i];
	}
	return *this;
}
