#include "stdafx.h"
#include "variable.h"

#include "VariableManager.h"
#include "Langobjs.h"

CVariable::CVariable(CCommand *newparent,CString value,BOOL inasm)
{
	globalvar=0;
	usememory=0;
	parent=newparent;
	type=varInt;
	elements=0;
	accesses=0;
	stacklevel=-1;
	registeraccess="";
	oldregisteraccess="";
	needed=0;
	initialvalue=0;
	if(inasm)
	{
		name=value;
		direct=1;
		if(value[0]=='#')
			constant=1;
		else if(value[0]=='(')
			constant=1;
		else
		{
			constant=0;
		}
	}
	else
	{
		if(value[0]=='#')
			name=value;
		else
			name="#"+value;
		constant=1;
		direct=0;
	}
}

CString CVariable::DoneWith(BOOL cleanstack)
{
	needed=0;
	if(stacklevel!=-1&&cleanstack)
		return vmanager->CleanStack();
	return "";
}

int CVariable::GetSize()
{
	if(elements)
		return 4;
	switch(type)
	{
		case varNone:
			return 0;
		case varVoid:
			return 0;
		case varChar:
			return 1;
		case varInt:
			return 2;
		case varLong:
			return 4;
	}
	return 0;
}

CString CVariable::GetLengthIdentifier()
{
	switch(type)
	{
		case varNone:
			return "?";
		case varVoid:
			return "?";
		case varChar:
			return ".b";
		case varInt:
			return ".w";
		case varLong:
			return ".l";
	}
	return "?";
}

CString CVariable::GetMemoryAccess()
{
	if(name=="*")
	{
		return "("+initialvalue->GetRegisterAccess()+")";
	}
	if(stacklevel==-1)
	{
		if(globalvar)
			return name;
		if(direct)
			return name;
	   	return "";
	}
	int downstack=vmanager->stacklevel-stacklevel;
	if(downstack)
	{
		char temp[10];
		sprintf(temp,"%d",downstack);
		CString ret=temp;
		ret+="(a7)";
		return ret;
	}
	return "(a7)";
};

CString CVariable::Load(char dest,int place)
{
	if(globalvar)
		return "";
	needed=1;
	accesses--;
	if(name=="*")
	{
		return initialvalue->Load();
	}
	if(name=="&")
	{
 		return initialvalue->Load();
	}
	if(registeraccess!="")
	{
		if(!usememory)
			return "";
		return vmanager->PushVariable(this);
	}
	CString temp=vmanager->Load(this,dest,place);
	if(temp==NO_EMPTY_REGISTER)
	{
		if(stacklevel!=-1)
			return "";
		return vmanager->PushVariable(this);
	}
	return temp;
}

void CVariable::SetRegister(CString str)
{
	oldregisteraccess=registeraccess;
	registeraccess=str;
}

void CVariableManager::SetOwnedRegs(CRegisterHolder nregs,CCommand *parent)
{
	int i;
	for(i=0; i<8; i++)
	{
		if(nregs.dataregisters[i]==(CVariable *)-1||
			(nregs.dataregisters[i]!=regs.dataregisters[i]&&
			nregs.dataregisters[i]->IsParent(parent)))
			regs.dataregisters[i]=nregs.dataregisters[i];
	}
	for(i=0; i<8; i++)
	{
		if(nregs.addressregisters[i]==(CVariable *)-1||
			(nregs.addressregisters[i]!=regs.addressregisters[i]&&
			nregs.addressregisters[i]->IsParent(parent)))
			regs.addressregisters[i]=nregs.addressregisters[i];
	}
}

BOOL CVariable::IsPointer()
{
	if(elements)
		return 1;
	return 0;
}

int CVariable::SetStackLevel(int newlevel)
{
	oldstacklevel=stacklevel;
	stacklevel=newlevel;
	return stacklevel;
}

void CVariable::ReNeeded()
{
	if(needed)
		return;
	stacklevel=oldstacklevel;
	if(registeraccess=="")
		registeraccess=oldregisteraccess;
}
