#ifndef VARIABLEMANAGER_H
#define VARIABLEMANAGER_H

#include "StdAfx.h"
#include "RegisterHolder.h"
#include "variable.h"

class CVariableManager;
class CRegisterHolder;
extern CVariableManager * mainmanager;

class CVariableManager
{
	public:
		CVariableManager & operator=(CVariableManager& varman);
		CString Restore(CVariableManager *oldmanager);
	int stacklevel; //How much data is on the stack
	int stacknum; //How many variables are on the stack
	CRegisterHolder regs;
	CVariable **stack;
	CVariableManager()
	{
		stacklevel=0;
		stacknum=0;
	}
	CString PushVariable(CVariable *toadd,CString useaddr="");
	CString CleanStack();
	CString BackupVariables(CCommand *vparent,CRegisterHolder *oregs,
		CRegisterHolder *cregs=0);
	CString Load(CVariable *toload,char dest=0,int place=-1);
	//Changes all the registers to its equalent in nregs if it was changed by
	//parent.
	void SetOwnedRegs(CRegisterHolder nregs,CCommand *parent);
	CString SetDataRegister(int num,CVariable *newv)
	{
		//CString ret;
		if(regs.dataregisters[num])
		{
			//ret=PushVariable(regs.dataregisters[num]);
			regs.dataregisters[num]->SetRegister("");
		}
		regs.dataregisters[num]=newv;
		return "";
	}
	CString SetAddressRegister(int num,CVariable *newv)
	{
		//can't backupvariable here because of things like if
		//statements.
		if(regs.addressregisters[num])
		{
			//ret=PushVariable(regs.addressregisters[num]);
			regs.addressregisters[num]->SetRegister("");
		}
		regs.addressregisters[num]=newv;
		return "";
	}
};
#endif
